﻿Module XMLGrid
    Public Function Grid2XML(ByVal DataGridView2XML As DataGridView, ByVal ObjClasse As Object, ByVal CollectionType As System.Type, Optional ByRef FileXML As String = "") As Boolean
        Return Grid2XML(DataGridView2XML.DataSource, ObjClasse, _
                              CollectionType, FileXML)
    End Function

    Public Function Grid2XML(ByVal classDataSource As Object, ByVal ObjClasse As Object, ByVal CollectionType As System.Type, Optional ByRef FileXML As String = "") As Boolean

        Dim TemFile As Boolean = False
        Dim Gravou As Boolean = False

        If FileXML = "" Then
            Dim saveFileDialog1 As New SaveFileDialog()

            saveFileDialog1.FileName = FileXML
            saveFileDialog1.Filter = "txt files (*.XML)|*.XML|All files (*.*)|*.*"
            saveFileDialog1.FilterIndex = 1
            saveFileDialog1.RestoreDirectory = True

            If saveFileDialog1.ShowDialog() = DialogResult.OK Then
                FileXML = saveFileDialog1.FileName
                TemFile = True
            Else
                TemFile = False
            End If

        Else
            TemFile = True

        End If


        If TemFile Then
            '----------Serialize
            Dim writer As New System.Xml.Serialization.XmlSerializer(CollectionType)
            Dim file As New System.IO.StreamWriter(FileXML)


            For Each Temp In classDataSource
                ObjClasse.Add(Temp)
            Next

            writer.Serialize(file, ObjClasse)

            file.Close()
            '----------
            Gravou = True
        Else
            Gravou = False
        End If

        Return Gravou

    End Function


    Public Function XML2Grid(ByVal DataGridView2XML As DataGridView, ByVal ObjClasse As Object, _
                              ByVal CollectionType As System.Type, Optional ByRef FileXML As String = "") As Boolean

        Return XML2Grid(DataGridView2XML.DataSource, ObjClasse, _
                               CollectionType, FileXML)
    End Function

    Public Function XML2Grid(ByVal classDataSource As Object, ByVal ObjClasse As Object, _
                             ByVal CollectionType As System.Type, Optional ByRef FileXML As String = "") As Boolean
        Dim TemFile As Boolean = False
        Dim Leu As Boolean = False

        If FileXML = "" Then


            Dim OpenFileDialog1 As New OpenFileDialog()

            OpenFileDialog1.FileName = FileXML
            OpenFileDialog1.Filter = "txt files (*.XML)|*.XML|All files (*.*)|*.*"
            OpenFileDialog1.FilterIndex = 1
            OpenFileDialog1.RestoreDirectory = True

            If OpenFileDialog1.ShowDialog() = DialogResult.OK Then

                FileXML = OpenFileDialog1.FileName
                TemFile = True
            Else
                TemFile = False
            End If
        Else
            TemFile = True

        End If

        If TemFile Then
            Try
                '----------Deserialize
                Dim TempColl As New Object
                Dim reader As New System.Xml.Serialization.XmlSerializer(CollectionType)
                Dim file As New System.IO.StreamReader(FileXML)

                TempColl = reader.Deserialize(file)

                file.Close()
                '----------


                classDataSource.Clear()
                For Each Temp In TempColl
                    classDataSource.Add(Temp)
                Next


                Leu = True
            Catch ex As Exception
                MsgBox(ex.Message.ToString)


                Leu = False
            End Try

        Else
            Leu = False
        End If

        Return Leu

    End Function
End Module
